;; ev-var
(define (ev-var-fake i) (lambda () (lambda (env pk) (pk (env i)))))
(define (ev-var i) (lambda (env pk) (pk (env i))))

(define (ev-begin pi1 pi2)
   (lambda (env pk)
      ((ev pi1) env
		(lambda (v)
		   ((ev pi2) env pk)))))

;; ev-if
(define (ev-if pi pi1 pi2)
   (lambda (env pk)
      ((ev pi) env 
	       (lambda (v)
		  (if (boolify v)
		      ((ev pi1) env pk)
		      ((ev pi2) env pk))))))

;; ev-lambda
(define (ev-lambda1 i pi)
   (lambda (env pk)
      (pk (make-closure (lambda (v pk2)
			   ((ev pi) (extend i v env)
				    pk2))))))

;; closure representation
(define (make-closure val)
   `(closure ,val))

(define (closure->function val)
   (cadr val))

;; ev-funcall1
(define (ev-funcall1 pi1 pi2)
   (lambda (env pk)
      ((ev pi1) env
		(lambda (f)
		   ((ev pi2) env
			     (lambda (v)
				((closure->function f) v pk)))))))

(define fact (lambda (x) (if (= x 1) 1 (* x (fact (- x 1))))))

(define-library step0
   ((ev (expr '(fact 10))) env0 pk0))

(define-library step1
   ((ev fact) env pk1))
(define-library step2
   ((ev 10) env pk2))
(define-library step3
   ((ev (expr '(si (eg x 1) ... ...))) env pk3))
(define-library step4
   ((ev (expr '(eg x 1))) env pk4))
(define-library step5
   ((ev eg) env pk5))
(define-library step6
   ((ev x) env pk6))
(define-library step7
   ((ev 1) env pk7))
(define-library step8
   (if (boolify v3)
       ((ev (expr '1)) env pk8)
       ((ev (expr '(* x (fact (- x 1))))) env pk8)))
